## apache-arrow-adbc-20.tar.gz

=== c/CMakeLists.txt ===
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.

cmake_minimum_required(VERSION 3.18)
get_filename_component(REPOSITORY_ROOT ".." ABSOLUTE)
list(APPEND CMAKE_MODULE_PATH "${REPOSITORY_ROOT}/c/cmake_modules/")
include(AdbcVersion)
project(adbc
        VERSION "${ADBC_BASE_VERSION}"
        LANGUAGES C CXX)
set(CMAKE_C_STANDARD 99)
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
include(AdbcDefines)
include(BuildUtils)

include(CTest)

set(ADBC_TARGET_COMPILE_DEFINITIONS)
if(NOT ADBC_DEFINE_COMMON_ENTRYPOINTS)
  message(STATUS "Defining ADBC_NO_COMMON_ENTRYPOINTS")
  set(ADBC_TARGET_COMPILE_DEFINITIONS "ADBC_NO_COMMON_ENTRYPOINTS")
endif()

if(ADBC_WITH_VENDORED_FMT)
  add_subdirectory(vendor/fmt EXCLUDE_FROM_ALL)
  set_target_properties(fmt PROPERTIES POSITION_INDEPENDENT_CODE ON)
else()
  find_package(fmt REQUIRED)
endif()
if(ADBC_WITH_VENDORED_NANOARROW)
  add_subdirectory(vendor/nanoarrow)
else()
  find_package(nanoarrow REQUIRED)
endif()
add_subdirectory(driver/common)
add_subdirectory(driver/framework)

if(ADBC_BUILD_TESTS)
  add_subdirectory(validation)
endif()

if(ADBC_BUILD_BENCHMARKS)
  add_custom_target(all-benchmarks)
  add_custom_target(benchmark ctest -L benchmark)
  add_dependencies(benchmark all-benchmarks)
endif()

if(ADBC_INTEGRATION_DUCKDB)
  set(ADBC_DRIVER_MANAGER ON)
endif()

if(ADBC_DRIVER_FLIGHTSQL)
  install(FILES "${REPOSITORY_ROOT}/c/include/arrow-adbc/driver/flightsql.h"
          DESTINATION include/arrow-adbc/driver)
  add_subdirectory(driver/flightsql)
endif()

if(ADBC_DRIVER_MANAGER)
  install(FILES "${REPOSITORY_ROOT}/c/include/adbc_driver_manager.h" DESTINATION include)
  install(FILES "${REPOSITORY_ROOT}/c/include/arrow-adbc/adbc_driver_manager.h"
          DESTINATION include/arrow-adbc)
  add_subdirectory(driver_manager)
endif()

if(ADBC_DRIVER_POSTGRESQL)
  install(FILES "${REPOSITORY_ROOT}/c/include/arrow-adbc/driver/postgresql.h"
          DESTINATION include/arrow-adbc/driver)
  add_subdirectory(driver/postgresql)
endif()

if(ADBC_DRIVER_SQLITE)
  install(FILES "${REPOSITORY_ROOT}/c/include/arrow-adbc/driver/sqlite.h"
          DESTINATION include/arrow-adbc/driver)
  add_subdirectory(driver/sqlite)
endif()

if(ADBC_DRIVER_SNOWFLAKE)
  install(FILES "${REPOSITORY_ROOT}/c/include/arrow-adbc/driver/snowflake.h"
          DESTINATION include/arrow-adbc/driver)
  add_subdirectory(driver/snowflake)
endif()

if(ADBC_DRIVER_BIGQUERY)
  install(FILES "${REPOSITORY_ROOT}/c/include/arrow-adbc/driver/bigquery.h"
          DESTINATION include/arrow-adbc/driver)
  add_subdirectory(driver/bigquery)
endif()

if(ADBC_INTEGRATION_DUCKDB)
  add_subdirectory(integration/duckdb)
endif()

if(ADBC_BUILD_PYTHON)
  find_package(Python3 REQUIRED COMPONENTS Interpreter Development)

  if(NOT ADBC_BUILD_SHARED)
    message(FATAL_ERROR "Building Python requires ADBC_BUILD_SHARED=ON")
  endif()

  # NB: the Python packages require the driver manager to be installed,
  # but you don't technically need -DADBC_DRIVER_MANAGER=ON when installing
  # other Python packages. To be safe then, we always install the driver
  # manager package, regardless of the value of -DABC_DRIVER_MANAGER
  # --config-settings eidtable_mode=compat required due to
  # https://github.com/python/mypy/issues/13392
  add_custom_target(python
                    COMMAND ${Python3_EXECUTABLE} -m pip install --no-deps -e
                            "${REPOSITORY_ROOT}/python/adbc_driver_manager"
                            --config-settings editable_mode=compat)

  macro(adbc_install_python_package TARGET)
    string(TOUPPER ${TARGET} ${TARGET}_LIB_upper)
    add_custom_command(TARGET python
                       POST_BUILD
                       COMMAND ${CMAKE_COMMAND} -E env "ADBC_${${TARGET}_LIB_upper}_\
LIBRARY=$<TARGET_FILE:adbc_driver_${TARGET}_shared>" ${Python3_EXECUTABLE} -m pip install
                               --no-deps -e
                               "${REPOSITORY_ROOT}/python/adbc_driver_${TARGET}"
                       COMMENT "pip installing the adbc_driver_${TARGET} library..."
                               DEPENDS $<TARGET_FILE:adbc_driver_${TARGET}_shared>
                       WORKING_DIRECTORY ${REPOSITORY_ROOT})
  endmacro()

  if(ADBC_DRIVER_POSTGRESQL)
    adbc_install_python_package(postgresql)
  endif()

  if(ADBC_DRIVER_SQLITE)
    adbc_install_python_package(sqlite)
  endif()

  if(ADBC_DRIVER_FLIGHTSQL)
    adbc_install_python_package(flightsql)
  endif()

  if(ADBC_DRIVER_SNOWFLAKE)
    adbc_install_python_package(snowflake)
  endif()

  if(ADBC_DRIVER_BIGQUERY)
    adbc_install_python_package(bigquery)
  endif()
endif()

validate_config()
config_summary_message()

=== glib/meson_options.txt ===
# -*- indent-tabs-mode: nil -*-
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.

option('adbc_build_dir',
       type: 'string',
       value: '',
       description: 'Use this option to build with not installed ADBC')

option('example',
       type: 'boolean',
       value: false,
       description: 'Build example')

option('vapi',
       type: 'boolean',
       value: false,
       description: 'Build Vala API')

=== java/CMakeLists.txt ===
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.

cmake_minimum_required(VERSION 3.16)
message(STATUS "Building using CMake version: ${CMAKE_VERSION}")

# find_package() uses <PackageName>_ROOT variables.
# https://cmake.org/cmake/help/latest/policy/CMP0074.html
if(POLICY CMP0074)
  cmake_policy(SET CMP0074 NEW)
endif()

project(adbc-java)

if("${CMAKE_CXX_STANDARD}" STREQUAL "")
  set(CMAKE_CXX_STANDARD 17)
endif()
set(CMAKE_CXX_STANDARD_REQUIRED ON)

include(GNUInstallDirs)

# Dependencies

find_package(Java REQUIRED)
find_package(JNI REQUIRED)

include(UseJava)

# ADBC_ARCH_DIR is derived from the architecture. The user can override this
# variable if auto-detection fails.
if("${ADBC_ARCH_DIR}" STREQUAL "")
  if("${CMAKE_SYSTEM_PROCESSOR}" STREQUAL "aarch64")
    set(ADBC_ARCH_DIR "aarch_64")
  elseif("${CMAKE_SYSTEM_PROCESSOR}" STREQUAL "i386")
    set(ADBC_ARCH_DIR "x86_64")
  elseif("${CMAKE_SYSTEM_PROCESSOR}" STREQUAL "arm64")
    set(ADBC_ARCH_DIR "aarch_64")
  elseif("${CMAKE_SYSTEM_PROCESSOR}" STREQUAL "AMD64")
    set(ADBC_ARCH_DIR "x86_64")
  elseif("${CMAKE_SYSTEM_PROCESSOR}" STREQUAL "x86_64")
    set(ADBC_ARCH_DIR "x86_64")
  else()
    message(FATAL_ERROR "Unsupported architecture: ${CMAKE_SYSTEM_PROCESSOR}")
  endif()
endif()

add_subdirectory(driver/jni)

=== c/driver_manager/CMakeLists.txt ===
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.

set(ADBC_DRIVER_MANAGER_SHARED_LINK_LIBS ${CMAKE_DL_LIBS})
set(ADBC_DRIVER_MANAGER_STATIC_LINK_LIBS ${CMAKE_DL_LIBS})
# std::filesystem with old g++/clang++ require libstdc++fs/libc++fs.
if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
  if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS "9")
    list(APPEND ADBC_DRIVER_MANAGER_SHARED_LINK_LIBS stdc++fs)
    list(APPEND ADBC_DRIVER_MANAGER_STATIC_LINK_LIBS stdc++fs)
  endif()
elseif(CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
  if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS "8")
    list(APPEND ADBC_DRIVER_MANAGER_SHARED_LINK_LIBS c++fs)
    list(APPEND ADBC_DRIVER_MANAGER_STATIC_LINK_LIBS c++fs)
  endif()
endif()

if(WIN32)
  list(APPEND
       ADBC_DRIVER_MANAGER_SHARED_LINK_LIBS
       advapi32
       uuid
       shell32)
  list(APPEND
       ADBC_DRIVER_MANAGER_STATIC_LINK_LIBS
       advapi32
       uuid
       shell32)
endif()

add_arrow_lib(adbc_driver_manager
              SOURCES
              adbc_driver_manager.cc
              OUTPUTS
              ADBC_LIBRARIES
              CMAKE_PACKAGE_NAME
              AdbcDriverManager
              PKG_CONFIG_NAME
              adbc-driver-manager
              SHARED_LINK_LIBS
              ${ADBC_DRIVER_MANAGER_SHARED_LINK_LIBS}
              STATIC_LINK_LIBS
              ${ADBC_DRIVER_MANAGER_STATIC_LINK_LIBS}
              SHARED_LINK_FLAGS
              ${ADBC_LINK_FLAGS})

install(FILES "${REPOSITORY_ROOT}/c/include/adbc.h" DESTINATION include)
install(FILES "${REPOSITORY_ROOT}/c/include/arrow-adbc/adbc.h"
        DESTINATION include/arrow-adbc)

foreach(LIB_TARGET ${ADBC_LIBRARIES})
  target_include_directories(${LIB_TARGET} SYSTEM
                             PRIVATE ${REPOSITORY_ROOT}/c/ ${REPOSITORY_ROOT}/c/include/
                                     ${REPOSITORY_ROOT}/c/vendor
                                     ${REPOSITORY_ROOT}/c/driver)
  target_compile_definitions(${LIB_TARGET} PRIVATE ADBC_EXPORTING)
  if("$ENV{CONDA_BUILD}" STREQUAL "1")
    target_compile_definitions(${LIB_TARGET} PRIVATE ADBC_CONDA_BUILD=1)
  else()
    target_compile_definitions(${LIB_TARGET} PRIVATE ADBC_CONDA_BUILD=0)
  endif()
endforeach()

if(ADBC_BUILD_TESTS)
  if(ADBC_TEST_LINKAGE STREQUAL "shared")
    set(TEST_LINK_LIBS adbc_driver_manager_shared)
  else()
    set(TEST_LINK_LIBS adbc_driver_manager_static)
  endif()

  add_test_case(driver_manager_test
                PREFIX
                adbc
                EXTRA_LABELS
                driver-manager
                SOURCES
                adbc_driver_manager_test.cc
                EXTRA_LINK_LIBS
                adbc_driver_common
                adbc_validation
                ${TEST_LINK_LIBS})
  target_compile_features(adbc-driver-manager-test PRIVATE cxx_std_17)

  if(ADBC_DRIVER_SQLITE)
    target_compile_definitions(adbc-driver-manager-test
                               PRIVATE ADBC_DRIVER_MANAGER_TEST_LIB="${CMAKE_BINARY_DIR}/driver/sqlite/libadbc_driver_sqlite${CMAKE_SHARED_LIBRARY_SUFFIX}"
    )
  endif()
  if(ADBC_DRIVER_MANAGER_TEST_MANIFEST_USER_LEVEL)
    target_compile_definitions(adbc-driver-manager-test
                               PRIVATE ADBC_DRIVER_MANAGER_TEST_MANIFEST_USER_LEVEL=1)
  endif()
  if(ADBC_DRIVER_MANAGER_TEST_MANIFEST_SYSTEM_LEVEL)
    target_compile_definitions(adbc-driver-manager-test
                               PRIVATE ADBC_DRIVER_MANAGER_TEST_MANIFEST_SYSTEM_LEVEL=1)
  endif()
  target_include_directories(adbc-driver-manager-test SYSTEM
                             PRIVATE ${REPOSITORY_ROOT}/c/ ${REPOSITORY_ROOT}/c/include/
                                     ${LIBPQ_INCLUDE_DIRS} ${REPOSITORY_ROOT}/c/driver)

  add_test_case(version_100_compatibility_test
                PREFIX
                adbc
                EXTRA_LABELS
                driver-manager
                SOURCES
                adbc_version_100.c
                adbc_version_100_compatibility_test.cc
                EXTRA_LINK_LIBS
                adbc_validation_util
                ${TEST_LINK_LIBS})
  target_compile_features(adbc-version-100-compatibility-test PRIVATE cxx_std_17)
  target_include_directories(adbc-version-100-compatibility-test SYSTEM
                             PRIVATE ${REPOSITORY_ROOT}/c/ ${REPOSITORY_ROOT}/c/include/
                                     ${LIBPQ_INCLUDE_DIRS} ${REPOSITORY_ROOT}/c/driver)
endif()

=== c/validation/CMakeLists.txt ===
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.

add_library(adbc_validation_util STATIC adbc_validation_util.cc)
adbc_configure_target(adbc_validation_util)
target_compile_features(adbc_validation_util PRIVATE cxx_std_17)
target_include_directories(adbc_validation_util SYSTEM
                           PRIVATE "${REPOSITORY_ROOT}/c/include/"
                                   "${REPOSITORY_ROOT}/c/driver/")
target_link_libraries(adbc_validation_util PUBLIC adbc_driver_common GTest::gtest
                                                  GTest::gmock)

add_library(adbc_validation OBJECT
            adbc_validation.cc adbc_validation_connection.cc adbc_validation_database.cc
            adbc_validation_statement.cc)
adbc_configure_target(adbc_validation)
target_compile_features(adbc_validation PRIVATE cxx_std_17)
target_include_directories(adbc_validation SYSTEM PRIVATE "${REPOSITORY_ROOT}/c/include/"
                                                          "${REPOSITORY_ROOT}/c/driver/")
target_link_libraries(adbc_validation PUBLIC adbc_driver_common adbc_validation_util
                                             GTest::gtest GTest::gmock)

=== r/adbcbigquery/DESCRIPTION ===
Package: adbcbigquery
Title: 'Arrow' Database Connectivity ('ADBC') 'BigQuery' Driver
Version: 0.20.0
Authors@R: c(
      person("Dewey", "Dunnington", , "dewey@dunnington.ca", role = c("aut", "cre"),
             comment = c(ORCID = "0000-0002-9415-4582")),
      person("Apache Arrow", email = "dev@arrow.apache.org", role = c("aut", "cph")),
      person("Apache Software Foundation", email = "dev@arrow.apache.org", role = c("cph"))
    )
Description: Provides a developer-facing interface to the 'Arrow' Database
  Connectivity ('ADBC') 'BigQuery' driver  for the purposes of building high-level
  database interfaces for users. 'ADBC' <https://arrow.apache.org/adbc/> is
  an API standard for database access libraries that uses 'Arrow' for result
  sets and query parameters.
License: Apache License (>= 2)
Encoding: UTF-8
Roxygen: list(markdown = TRUE)
RoxygenNote: 7.3.2
Suggests:
    gargle,
    nanoarrow,
    testthat (>= 3.0.0)
SystemRequirements: GNU make, Go (>= 1.21)
Config/testthat/edition: 3
Config/build/bootstrap: TRUE
URL: https://arrow.apache.org/adbc/current/r/adbcbigquery/, https://github.com/apache/arrow-adbc
BugReports: https://github.com/apache/arrow-adbc/issues
Imports: adbcdrivermanager

=== r/adbcdrivermanager/DESCRIPTION ===
Package: adbcdrivermanager
Title: 'Arrow' Database Connectivity ('ADBC') Driver Manager
Version: 0.20.0
Authors@R: c(
      person("Dewey", "Dunnington", , "dewey@dunnington.ca", role = c("aut", "cre"),
             comment = c(ORCID = "0000-0002-9415-4582")),
      person("Apache Arrow", email = "dev@arrow.apache.org", role = c("aut", "cph")),
      person("Apache Software Foundation", email = "dev@arrow.apache.org", role = c("cph"))
    )
Description: Provides a developer-facing interface to 'Arrow' Database
  Connectivity ('ADBC') for the purposes of driver development, driver
  testing, and building high-level database interfaces for users. 'ADBC'
  <https://arrow.apache.org/adbc/> is an API standard for database access
  libraries that uses 'Arrow' for result sets and query parameters.
License: Apache License (>= 2)
Encoding: UTF-8
Roxygen: list(markdown = TRUE)
RoxygenNote: 7.3.2
Suggests:
    testthat (>= 3.0.0),
    withr
Config/testthat/edition: 3
Config/build/bootstrap: TRUE
URL: https://arrow.apache.org/adbc/current/r/adbcdrivermanager/, https://github.com/apache/arrow-adbc
BugReports: https://github.com/apache/arrow-adbc/issues
Imports:
    nanoarrow (>= 0.3.0)

=== r/adbcflightsql/DESCRIPTION ===
Package: adbcflightsql
Title: 'Arrow' Database Connectivity ('ADBC') 'FlightSQL' Driver
Version: 0.20.0
Authors@R: c(
      person("Dewey", "Dunnington", , "dewey@dunnington.ca", role = c("aut", "cre"),
             comment = c(ORCID = "0000-0002-9415-4582")),
      person("Apache Arrow", email = "dev@arrow.apache.org", role = c("aut", "cph")),
      person("Apache Software Foundation", email = "dev@arrow.apache.org", role = c("cph"))
    )
Description: Provides a developer-facing interface to the 'Arrow' Database
  Connectivity ('ADBC') 'FlightSQL' driver  for the purposes of building high-level
  database interfaces for users. 'ADBC' <https://arrow.apache.org/adbc/> is
  an API standard for database access libraries that uses 'Arrow' for result
  sets and query parameters.
License: Apache License (>= 2)
Encoding: UTF-8
Roxygen: list(markdown = TRUE)
RoxygenNote: 7.2.3
Suggests:
    nanoarrow,
    testthat (>= 3.0.0)
SystemRequirements: GNU make, Go (>= 1.21)
Config/testthat/edition: 3
Config/build/bootstrap: TRUE
URL: https://arrow.apache.org/adbc/current/r/adbcflightsql/, https://github.com/apache/arrow-adbc
BugReports: https://github.com/apache/arrow-adbc/issues
Imports: adbcdrivermanager

=== r/adbcpostgresql/DESCRIPTION ===
Package: adbcpostgresql
Title: 'Arrow' Database Connectivity ('ADBC') 'PostgreSQL' Driver
Version: 0.20.0
Authors@R: c(
      person("Dewey", "Dunnington", , "dewey@dunnington.ca", role = c("aut", "cre"),
             comment = c(ORCID = "0000-0002-9415-4582")),
      person("Apache Arrow", email = "dev@arrow.apache.org", role = c("aut", "cph")),
      person("Apache Software Foundation", email = "dev@arrow.apache.org", role = c("cph"))
    )
Description: Provides a developer-facing interface to the 'Arrow' Database
  Connectivity ('ADBC') 'PostgreSQL' driver for the purposes of building high-level
  database interfaces for users. 'ADBC' <https://arrow.apache.org/adbc/> is
  an API standard for database access libraries that uses 'Arrow' for result
  sets and query parameters.
License: Apache License (>= 2)
Encoding: UTF-8
Roxygen: list(markdown = TRUE)
RoxygenNote: 7.3.2
SystemRequirements: libpq
Suggests:
    nanoarrow,
    testthat (>= 3.0.0)
Config/testthat/edition: 3
Config/build/bootstrap: TRUE
URL: https://arrow.apache.org/adbc/current/r/adbcpostgresql/, https://github.com/apache/arrow-adbc
BugReports: https://github.com/apache/arrow-adbc/issues
Imports: adbcdrivermanager

=== r/adbcsnowflake/DESCRIPTION ===
Package: adbcsnowflake
Title: Arrow Database Connectivity ('ADBC') 'Snowflake' Driver
Version: 0.20.0
Authors@R: c(
      person("Dewey", "Dunnington", , "dewey@dunnington.ca", role = c("aut", "cre"),
             comment = c(ORCID = "0000-0002-9415-4582")),
      person("Apache Arrow", email = "dev@arrow.apache.org", role = c("aut", "cph")),
      person("Apache Software Foundation", email = "dev@arrow.apache.org", role = c("cph"))
    )
Description: Provides a developer-facing interface to the 'Arrow' Database
  Connectivity ('ADBC') 'Snowflake' driver for the purposes of building high-level
  database interfaces for users. 'ADBC' <https://arrow.apache.org/adbc/> is
  an API standard for database access libraries that uses 'Arrow' for result
  sets and query parameters.
License: Apache License (>= 2)
Encoding: UTF-8
Roxygen: list(markdown = TRUE)
RoxygenNote: 7.2.3
Suggests:
    nanoarrow,
    openssl,
    testthat (>= 3.0.0)
SystemRequirements: GNU make, Go (>= 1.21)
Config/testthat/edition: 3
Config/build/bootstrap: TRUE
URL: https://arrow.apache.org/adbc/current/r/adbcsnowflake/, https://github.com/apache/arrow-adbc
BugReports: https://github.com/apache/arrow-adbc/issues
Imports: adbcdrivermanager

=== r/adbcsqlite/DESCRIPTION ===
Package: adbcsqlite
Title: 'Arrow' Database Connectivity ('ADBC') 'SQLite' Driver
Version: 0.20.0
Authors@R: c(
      person("Dewey", "Dunnington", , "dewey@dunnington.ca", role = c("aut", "cre"),
             comment = c(ORCID = "0000-0002-9415-4582")),
      person("Apache Arrow", email = "dev@arrow.apache.org", role = c("aut", "cph")),
      person("Apache Software Foundation", email = "dev@arrow.apache.org", role = c("cph"))
    )
Description: Provides a developer-facing interface to the 'Arrow' Database
  Connectivity ('ADBC') 'SQLite' driver for the purposes of building high-level
  database interfaces for users. 'ADBC' <https://arrow.apache.org/adbc/> is
  an API standard for database access libraries that uses 'Arrow' for result
  sets and query parameters.
License: Apache License (>= 2)
Encoding: UTF-8
Roxygen: list(markdown = TRUE)
RoxygenNote: 7.3.2
SystemRequirements: SQLite3
Suggests:
    nanoarrow,
    testthat (>= 3.0.0)
Config/testthat/edition: 3
Config/build/bootstrap: TRUE
URL: https://arrow.apache.org/adbc/current/r/adbcsqlite/, https://github.com/apache/arrow-adbc
BugReports: https://github.com/apache/arrow-adbc/issues
Imports: adbcdrivermanager

=== c/driver/flightsql/CMakeLists.txt ===
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.

include(GoUtils)

set(LDFLAGS "$<$<CONFIG:Release>:-s> $<$<CONFIG:Release>:-w>")
add_go_lib("${REPOSITORY_ROOT}/go/adbc/pkg/flightsql/"
           adbc_driver_flightsql
           SOURCES
           driver.go
           utils.h
           utils.c
           BUILD_TAGS
           driverlib
           CMAKE_PACKAGE_NAME
           AdbcDriverFlightSQL
           PKG_CONFIG_NAME
           adbc-driver-flightsql
           SHARED_LINK_FLAGS
           ${LDFLAGS}
           DEFINES
           ${ADBC_TARGET_COMPILE_DEFINITIONS}
           OUTPUTS
           ADBC_LIBRARIES)

foreach(LIB_TARGET ${ADBC_LIBRARIES})
  target_include_directories(${LIB_TARGET} SYSTEM
                             INTERFACE ${REPOSITORY_ROOT}/c/
                                       ${REPOSITORY_ROOT}/c/include/
                                       ${REPOSITORY_ROOT}/c/driver)
endforeach()

if(ADBC_TEST_LINKAGE STREQUAL "shared")
  set(TEST_LINK_LIBS adbc_driver_flightsql_shared)
else()
  set(TEST_LINK_LIBS adbc_driver_flightsql_static)
endif()

if(ADBC_BUILD_TESTS)
  add_test_case(driver_flightsql_test
                PREFIX
                adbc
                EXTRA_LABELS
                driver-flightsql
                SOURCES
                dremio_flightsql_test.cc
                sqlite_flightsql_test.cc
                EXTRA_LINK_LIBS
                adbc_driver_common
                adbc_validation
                ${TEST_LINK_LIBS})
  target_compile_features(adbc-driver-flightsql-test PRIVATE cxx_std_17)
  target_include_directories(adbc-driver-flightsql-test SYSTEM
                             PRIVATE ${REPOSITORY_ROOT}/c/ ${REPOSITORY_ROOT}/c/include/
                                     ${REPOSITORY_ROOT}/c/driver)
  adbc_configure_target(adbc-driver-flightsql-test)
endif()

=== ci/linux-packages/debian/changelog ===
apache-arrow-adbc (20-1) unstable; urgency=low

  * New upstream release.

 -- David Li <li.davidm96@gmail.com>  Tue, 09 Sep 2025 05:58:33 -0000

apache-arrow-adbc (0.1.0-1) unstable; urgency=low

  * New upstream release.

 -- Sutou Kouhei <kou@clear-code.com>  Mon, 26 Dec 2022 02:13:01 -0000

=== ci/linux-packages/debian/control ===
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.

Source: apache-arrow-adbc
Section: devel
Priority: optional
Maintainer: Apache Arrow Developers <dev@arrow.apache.org>
Build-Depends:
  cmake,
  debhelper-compat (= 12),
  gobject-introspection,
  golang | golang-1.21,
  libarrow-glib-dev,
  libgirepository1.0-dev,
  libpq-dev,
  libsqlite3-dev,
  meson,
  tzdata,
  valac
Standards-Version: 4.5.0
Homepage: https://arrow.apache.org/adbc/

Package: libadbc-driver-manager108
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
  ${misc:Depends},
  ${shlibs:Depends}
Description: Apache Arrow Database Connectivity (ADBC) driver manager
 .
 This package provides C++ library files.

Package: libadbc-driver-manager-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
  ${misc:Depends},
  libadbc-driver-manager108 (= ${binary:Version})
Description: Apache Arrow Database Connectivity (ADBC) driver manager
 .
 This package provides C++ header files.

Package: libadbc-driver-postgresql108
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
  ${misc:Depends},
  ${shlibs:Depends}
Description: Apache Arrow Database Connectivity (ADBC) PostgreSQL driver
 .
 This package provides an ADBC driver for PostgreSQL

Package: libadbc-driver-postgresql-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
  ${misc:Depends},
  libadbc-driver-postgresql108 (= ${binary:Version})
Description: Apache Arrow Database Connectivity (ADBC) PostgreSQL driver
 .
 This package provides CMake package, pkg-config package and so on.

Package: libadbc-driver-sqlite108
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
  ${misc:Depends},
  ${shlibs:Depends}
Description: Apache Arrow Database Connectivity (ADBC) PostgreSQL driver
 .
 This package provides an ADBC driver for PostgreSQL

Package: libadbc-driver-sqlite-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
  ${misc:Depends},
  libadbc-driver-sqlite108 (= ${binary:Version})
Description: Apache Arrow Database Connectivity (ADBC) SQLite driver
 .
 This package provides CMake package, pkg-config package and so on.

Package: libadbc-driver-flightsql108
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
  ${misc:Depends},
  ${shlibs:Depends}
Description: Apache Arrow Database Connectivity (ADBC) Flight SQL driver
 .
 This package provides an ADBC driver for Flight SQL

Package: libadbc-driver-flightsql-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
  ${misc:Depends},
  libadbc-driver-flightsql108 (= ${binary:Version})
Description: Apache Arrow Database Connectivity (ADBC) Flight SQL driver
 .
 This package provides CMake package, pkg-config package and so on.

Package: libadbc-driver-snowflake108
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
  ${misc:Depends},
  ${shlibs:Depends}
Description: Apache Arrow Database Connectivity (ADBC) Snowflake driver
 .
 This package provides an ADBC driver for Snowflake

Package: libadbc-driver-snowflake-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
  ${misc:Depends},
  libadbc-driver-snowflake108 (= ${binary:Version})
Description: Apache Arrow Database Connectivity (ADBC) Snowflake driver
 .
 This package provides CMake package, pkg-config package and so on.


Package: libadbc-glib1
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
  ${misc:Depends},
  ${shlibs:Depends},
  libadbc-driver-manager108 (= ${binary:Version})
Description: Apache Arrow Database Connectivity (ADBC) driver manager
 .
 This package provides GLib based library files.

Package: gir1.2-adbc-1.0
Section: introspection
Architecture: any
Multi-Arch: same
Depends:
  ${gir:Depends},
  ${misc:Depends}
Description: Apache Arrow Database Connectivity (ADBC) driver manager
 .
 This package provides GObject Introspection typelib files.

Package: libadbc-glib-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
  ${misc:Depends},
  gir1.2-adbc-1.0 (= ${binary:Version}),
  libadbc-driver-manager-dev (= ${binary:Version})
Description: Apache Arrow Database Connectivity (ADBC) driver manager
 .
 This package provides GLib based header files.

Package: libadbc-glib-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends:
  ${misc:Depends}
Recommends:
  libglib2.0-doc,
  libarrow-glib-doc
Description: Apache Arrow Database Connectivity (ADBC) driver manager
 .
 This package provides documentations.

Package: libadbc-arrow-glib1
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
  ${misc:Depends},
  ${shlibs:Depends},
  libadbc-glib1 (= ${binary:Version})
Description: Apache Arrow Database Connectivity (ADBC) driver manager
 .
 This package provides library files for Apache Arrow GLib integration.

Package: gir1.2-adbc-arrow-1.0
Section: introspection
Architecture: any
Multi-Arch: same
Depends:
  ${gir:Depends},
  ${misc:Depends},
  gir1.2-adbc-1.0 (= ${binary:Version})
Description: Apache Arrow Database Connectivity (ADBC) driver manager
 .
 This package provides GObject Introspection typelib files for Apache
 Arrow GLib integration.

Package: libadbc-arrow-glib-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
  ${misc:Depends},
  gir1.2-adbc-arrow-1.0 (= ${binary:Version}),
  libadbc-glib-dev (= ${binary:Version})
Description: Apache Arrow Database Connectivity (ADBC) driver manager
 .
 This package provides header files for Apache Arrow GLib
 integration.

Package: libadbc-arrow-glib-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends:
  ${misc:Depends}
Recommends:
  libglib2.0-doc,
  libadbc-glib-doc,
  libarrow-glib-doc
Description: Apache Arrow Database Connectivity (ADBC) driver manager
 .
 This package provides documentations for Apache Arrow GLib
 integration.

=== ci/linux-packages/debian/rules ===
#!/usr/bin/make -f
# -*- makefile-gmake -*-
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
# This has to be exported to make some magic below work.
export DH_OPTIONS

export DEB_BUILD_MAINT_OPTIONS=reproducible=-timeless

%:
	dh $@ --with gir

CMAKE_BUILD_TYPE = RelWithDebInfo

override_dh_auto_configure:
	env						\
	  PATH=/usr/lib/go-1.21/bin:$${PATH}		\
	  dh_auto_configure				\
	    --sourcedirectory=c/			\
	    --builddirectory=c.build			\
	    --buildsystem=cmake+ninja			\
	    --						\
	    -DCMAKE_BUILD_TYPE=$(CMAKE_BUILD_TYPE)	\
	    -DADBC_DRIVER_FLIGHTSQL=ON			\
	    -DADBC_DRIVER_MANAGER=ON			\
	    -DADBC_DRIVER_POSTGRESQL=ON			\
	    -DADBC_DRIVER_SNOWFLAKE=ON			\
	    -DADBC_DRIVER_SQLITE=ON

override_dh_auto_build:
	dh_auto_build				\
	  --sourcedirectory=c			\
	  --builddirectory=c.build
	dh_auto_configure				\
	  --sourcedirectory=glib			\
	  --builddirectory=glib.build			\
	  --buildsystem=meson+ninja			\
	  --						\
	  --buildtype=debugoptimized			\
	  -Dadbc_build_dir=../c.build/driver_manager	\
	  -Dvapi=true
	env							\
	  LD_LIBRARY_PATH=$(CURDIR)/c.build/driver_manager	\
	    dh_auto_build					\
	      --sourcedirectory=glib				\
	      --builddirectory=glib.build			\
	      --buildsystem=meson+ninja

override_dh_auto_install:
	dh_auto_install				\
	  --sourcedirectory=c			\
	  --builddirectory=c.build
	dh_auto_install				\
	   --sourcedirectory=glib		\
	   --builddirectory=glib.build		\
	   --buildsystem=meson+ninja

override_dh_auto_test:

override_dh_dwz:
	# libadbc_driver_flightsql.so.* has compressed DWARF.
	# We can't use dwz for compressed DWARF.
	dh_dwz \
		--exclude=libadbc_driver_flightsql \
		--exclude=libadbc_driver_postgresql \
		--exclude=libadbc_driver_snowflake \
		--exclude=libadbc_driver_sqlite
